VERSION 5.00
Begin VB.Form frmMain 
   BackColor       =   &H00000000&
   Caption         =   "VB MotionBlur"
   ClientHeight    =   6135
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   6360
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   12
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   409
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   424
   StartUpPosition =   3  'Windows Default
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuGoStop 
         Caption         =   "Go/Stop"
         Shortcut        =   {F3}
      End
      Begin VB.Menu mnuSingleStep 
         Caption         =   "Single Step"
         Shortcut        =   {F4}
      End
      Begin VB.Menu mnuFileLine1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuChangeDevice 
         Caption         =   "Change Device..."
         Shortcut        =   {F2}
      End
      Begin VB.Menu mnuFileLine2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuExit 
         Caption         =   "E&xit          ESC"
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Option Explicit

Dim m_bInit As Boolean                  'indicates d3d has been initialized
Dim m_bMinimized As Boolean             'indicates display window is minimized
Dim m_bIsRunning As Boolean             'indicates animation is running

Dim m_fTime As Single
Dim m_LastTime As Single
Dim m_FrameCount As Long
Dim m_fps As Single


Dim m_status_font As D3DXFont
Dim m_StatsRect As RECT
Dim m_NumSegments As Long

Dim m_status_text As String
Dim m_status_hold As String

Dim LightDesc As D3DLIGHT8
Dim c As D3DCOLORVALUE
Dim vPos As D3DVECTOR

Private colMotionRings As colRings

'-----------------------------------------------------------------------------
'Name: GetCurrentDeviceName
'Desc: Returns a string that describes the current D3D device.
'-----------------------------------------------------------------------------
Private Function GetCurrentDeviceName() As String
    Dim sDescription As String
    
    sDescription = StrConv(g_Adapters(g_lCurrentAdapter).d3dai.Description, vbUnicode)
    sDescription = Replace(sDescription, Chr$(0), "")
    
    'do we have a description?
    If sDescription = "" Then
        GetCurrentDeviceName = "Unknown Device"
    Else
        'return device description
        GetCurrentDeviceName = sDescription
    End If
End Function

'-----------------------------------------------------------------------------
'Name: Form_Load()
'Desc: Application starting point and main processing loop.
'-----------------------------------------------------------------------------
Private Sub Form_Load()
    On Error Resume Next
    
    'set defaults
    m_NumSegments = 30
    
    'force form to show now
    Me.Show
    DoEvents
    
    Randomize
    
    'Initialize D3D
    'Note: D3DUtil_Init will attempt to use D3D Hardware acceleration.
    'If not available, it will attempt to use the Software Reference Rasterizer.
    'If everything fails, it will display a message box indicating so.
    m_bInit = D3DUtil_Init(Me.hwnd, True, 0, 0, D3DDEVTYPE_HAL, Me)
    If Not (m_bInit) Then End
    
    'sets the state for the objects and the current D3D device
    RestoreDeviceObjects
    
    'start application timer
    DXUtil_Timer TIMER_start
    m_bIsRunning = True

    Set texMaterial = g_d3dx.CreateTextureFromFile(g_dev, App.path & "\material.bmp")
    
    Set colMotionRings = New colRings
    Dim I As Long
    For I = 1 To 2
        colMotionRings.Add 1 * Rnd, 1 * Rnd, 359 * Rnd, timeGetTime, 0, 0, 0, 0, 5
    Next I
    
    
    
    
    Dim matTemp As D3DMATRIX
    'run the simulation forever
    'see Form_Keydown for exit processing
    Do While True
        DoEvents
        'begin scene
        g_dev.BeginScene
        
        'clear the target and zbuffer
        g_dev.Clear 0&, ByVal 0&, D3DCLEAR_TARGET Or D3DCLEAR_ZBUFFER, 0, 1!, 0&
        
        colMotionRings.Update
        colMotionRings.Render

        'end scene
        g_dev.EndScene
    
        g_dev.Present ByVal 0, ByVal 0, g_focushwnd, ByVal 0
        
        'allow for events to get processed
        DoEvents
    Loop
End Sub

'-----------------------------------------------------------------------------
'Name: Form_KeyDown()
'Desc: Process key messages for exit and change device
'-----------------------------------------------------------------------------
Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    Dim hr As Long
    
    Select Case KeyCode
        Case vbKeyEscape
            'escape to exit
            Unload Me
            
        Case vbKeyF2
            'Pause the timer
            DXUtil_Timer TIMER_STOP
            
            'Bring up the device selection dialog
            'we pass in the form so the selection process
            'can make calls into InitDeviceObjects
            'and RestoreDeviceObjects
            frmSelectDevice.SelectDevice Me
            
            'Restart the timer
            DXUtil_Timer TIMER_start
            
        Case vbKeyReturn
            'Check for Alt-Enter, if not pressed exit
            If Shift <> 4 Then Exit Sub
            
            'we must invalidate objects before a reset
            InvalidateDeviceObjects
            
            'If we are windowed go fullscreen
            'If we are fullscreen returned to windowed
            If g_d3dpp.Windowed Then
                 hr = D3DUtil_ResetFullscreen
            Else
                 hr = D3DUtil_ResetWindowed
            End If
                             
            'Call Restore after every mode change
            'because calling reset looses states that need to
            'be reinitialized
            If hr = D3D_OK Then
                RestoreDeviceObjects
            End If
            
        Case vbKeyUp
            'add a segment to mesh
            m_NumSegments = m_NumSegments + 1
            If m_NumSegments > 100 Then m_NumSegments = 100
            UpdateShape
            UpdateStatusText
            
        Case vbKeyDown
            'remove a segment from mesh
            m_NumSegments = m_NumSegments - 1
            If m_NumSegments < 3 Then m_NumSegments = 3
            UpdateShape
            UpdateStatusText
            
        Case vbKeyPageUp
            'add 5 segments to mesh
            m_NumSegments = m_NumSegments + 5
            If m_NumSegments > 100 Then m_NumSegments = 100
            UpdateShape
            UpdateStatusText
            
        Case vbKeyPageDown
            'remove 5 segments from mesh
            m_NumSegments = m_NumSegments - 5
            If m_NumSegments < 3 Then m_NumSegments = 3
            UpdateShape
            UpdateStatusText
            
        Case vbKeyHome
            'make mesh 3 segments
            m_NumSegments = 3
            UpdateShape
            UpdateStatusText
            
        Case vbKeyEnd
            'make mesh 25 segments
            m_NumSegments = 25
            UpdateShape
            UpdateStatusText
    End Select
End Sub

'-----------------------------------------------------------------------------
'Name: Form_Resize()
'Desc: Handles resizing of the D3D backbuffer.
'-----------------------------------------------------------------------------
Private Sub Form_Resize()
    'If D3D is not initialized then exit
    If Not m_bInit Then Exit Sub
    
    'If we are in a minimized state stop the timer and exit
    If Me.WindowState = vbMinimized Then
        DXUtil_Timer TIMER_STOP
        m_bMinimized = True
        Exit Sub
        
    'If we just went from a minimized state to maximized
    'restart the timer
    Else
        If m_bMinimized = True Then
            If m_bIsRunning = True Then
                DXUtil_Timer TIMER_start
            End If
            m_bMinimized = False
        End If
    End If
    
    'dont let the window get too small
    If Me.ScaleWidth < 10 Then
        Me.width = Screen.TwipsPerPixelX * 10
        Exit Sub
    End If
    
    If Me.ScaleHeight < 10 Then
        Me.height = Screen.TwipsPerPixelY * 10
        Exit Sub
    End If
    
    'fonts must be destroyed before a reset
    InvalidateDeviceObjects
    
    'reset and resize our D3D backbuffer to the size of the window
    D3DUtil_ResizeWindowed Me.hwnd
    
    'All states get lost after a reset, so we need to re-initialize
    RestoreDeviceObjects
End Sub

'-----------------------------------------------------------------------------
'Name: Form_Unload()
'Desc: Destroys all objects that were in use by application.
'-----------------------------------------------------------------------------
Private Sub Form_Unload(Cancel As Integer)
    'destroy all objects
    InvalidateDeviceObjects
    DeleteDeviceObjects
    
    'destroy d3d stuff
    D3DUtil_Destory
    
    'end program
    End
End Sub

'-----------------------------------------------------------------------------
'Name: FrameMove()
'Desc: Called once per frame, the call is the entry point for animating
'      the scene.
'-----------------------------------------------------------------------------
Private Sub FrameMove()
    m_fTime = DXUtil_Timer(TIMER_GETABSOLUTETIME)
End Sub

'-----------------------------------------------------------------------------
'Name: SetStates()
'Desc: We set the renderstates appropriate for the mesh.
'-----------------------------------------------------------------------------
Private Sub SetStates()
    On Error Resume Next
    
    'setup device states to something reasonable for us
    With g_dev
        .SetRenderState D3DRS_CLIPPLANEENABLE, 0
        .SetRenderState D3DRS_CULLMODE, D3DCULL_CCW
        .SetRenderState D3DRS_FILLMODE, D3DFILL_SOLID
        .SetRenderState D3DRS_SHADEMODE, D3DSHADE_GOURAUD
        .SetRenderState D3DRS_CLIPPING, 1
        .SetRenderState D3DRS_LIGHTING, 1
        .SetRenderState D3DRS_LOCALVIEWER, 0
        .SetRenderState D3DRS_AMBIENT, 0
        .SetRenderState D3DRS_SPECULARENABLE, 1
        .SetRenderState D3DRS_ALPHATESTENABLE, 0
        .SetRenderState D3DRS_ZENABLE, D3DZB_TRUE
        .SetRenderState D3DRS_ZWRITEENABLE, 0
        .SetRenderState D3DRS_ZFUNC, D3DCMP_LESS
        .SetRenderState D3DRS_ZBIAS, 0
        .SetRenderState D3DRS_STENCILENABLE, 0
        .SetRenderState D3DRS_ALPHABLENDENABLE, 1
        .SetRenderState D3DRS_DITHERENABLE, 1
        .SetRenderState D3DRS_NORMALIZENORMALS, 1
        .SetRenderState D3DRS_COLORVERTEX, 0
        .SetRenderState D3DRS_AMBIENTMATERIALSOURCE, D3DMCS_MATERIAL
        .SetRenderState D3DRS_DIFFUSEMATERIALSOURCE, D3DMCS_MATERIAL
        .SetRenderState D3DRS_SPECULARMATERIALSOURCE, D3DMCS_MATERIAL
        .SetRenderState D3DRS_EMISSIVEMATERIALSOURCE, D3DMCS_MATERIAL
        .SetRenderState D3DRS_FILLMODE, D3DFILL_SOLID
    End With

    With Material
        'Set the RGBA for diffuse reflection.
        .diffuse.r = 0
        .diffuse.g = 0.3

        'Set the RGBA for ambient reflection.
        .Ambient = .diffuse
        
        'Set the color and sharpness of specular highlights.
        .Specular.r = 0.1
        .Specular.g = 0.3

        .power = 1
        
        'Set the RGBA for emissive color.
        .emissive.r = 0
        .emissive.g = 0
    End With
            
    'setup the light
    Dim light As D3DLIGHT8
    Call D3DUtil_InitLight(light, D3DLIGHT_DIRECTIONAL, -1!, -1!, -1!)

    
    g_dev.SetLight 0, light
    g_dev.LightEnable 0, 1
    
    'we'll use an identity matrix for our world transform, since we've
    'constructed the calls in the shape sub to keep the model inside
    'the shape [-1,1] on the three principal axes.
    Dim matWorld As D3DMATRIX
    D3DXMatrixIdentity matWorld
    g_dev.SetTransform D3DTS_WORLD, matWorld
    
    'we'll put the eye off to the corner of the shape and make it
    'look at the origin
    Dim matView As D3DMATRIX
    Dim vUpVec As D3DVECTOR
    Dim vEyePt As D3DVECTOR
    Dim vLookAtpt As D3DVECTOR
    Dim EyeLen As Single
    
    vEyePt = vec3(1, 1, 0)
    EyeLen = 2! * D3DXVec3Length(vEyePt)
    With vEyePt
        .X = .X / EyeLen
        .Y = .Y / EyeLen
        .z = .z / EyeLen
    End With
    
    vLookAtpt = vec3(0, 0, 0)
    vUpVec = vec3(0, 1, 0)
    
    D3DXMatrixLookAtLH matView, vEyePt, vLookAtpt, vUpVec
    g_dev.SetTransform D3DTS_VIEW, matView
    
    'we'll use an orghographic projection spanning [-1,1] on the three
    'principal axes
    Dim proj As D3DMATRIX
    D3DXMatrixOrthoLH proj, 3!, 3!, -5, 8!
    g_dev.SetTransform D3DTS_PROJECTION, proj
End Sub

'-----------------------------------------------------------------------------
'Name: OptimizeMesh()
'Desc: Optimizes a mesh in place.
'-----------------------------------------------------------------------------
Private Function OptimizeMesh(ByRef oMesh As D3DXMesh, _
                              ByRef Adj As D3DXBuffer) As Boolean
    Dim BufSize As Long
    Dim AdjacencyOut() As Long
    Dim FaceRemap() As Long
    Dim VertexRemapOut As D3DXBuffer
    
    On Error GoTo errOut
    
    'make room for enough Long values to represent the mesh data
    BufSize = Adj.GetBufferSize
    ReDim AdjacencyOut(BufSize / 4&)
    ReDim FaceRemap(BufSize / 4&)
    

    'optimize mesh data
    oMesh.OptimizeInplace D3DXMESHOPT_ATTRSORT, ByVal Adj.GetBufferPointer, AdjacencyOut(0), FaceRemap(0), VertexRemapOut

    OptimizeMesh = True
Exit Function

errOut:
    OptimizeMesh = False
End Function

'-----------------------------------------------------------------------------
'Name: UpdateStatusText()
'Desc:
'-----------------------------------------------------------------------------
Private Sub UpdateStatusText()
    Dim DispMode As D3DDISPLAYMODE
    Dim DevString As String
    Dim FormatString As String
    Dim BufferWidth As Long
    Dim BufferHeight As Long
    
    'get size of current back buffer
    If g_d3dpp.Windowed Then
        BufferWidth = g_lWindowWidth
        BufferHeight = g_lWindowHeight
    Else
        g_dev.GetDisplayMode DispMode
        BufferWidth = DispMode.width
        BufferHeight = DispMode.height
    End If
    
    'create status text
    If g_devType = D3DDEVTYPE_REF Then
        DevString = "REF: "
        
    Else
        'VB SDK framework does not detect and/or enable pure devices
        If g_behaviorflags Or D3DCREATE_HARDWARE_VERTEXPROCESSING = D3DCREATE_HARDWARE_VERTEXPROCESSING Then
            DevString = "HAL (hw vp): "
        Else
            DevString = "HAL (sw vp): "
        End If
    End If
    
    'get color depth
    If DispMode.format = D3DFMT_R5G6B5 Then
        FormatString = "x16"
    Else
        FormatString = "x32"
    End If
    
    'VB SDK framework always picks D16 depth format
    m_status_hold = " fps (" & BufferWidth & "x" & BufferHeight & FormatString & ") (D16)" & _
                vbCrLf & DevString & GetCurrentDeviceName & " " _
                & vbCrLf & format$(m_NumSegments, "###,##0") & " Segments, " _
                & format$(m_d3dx_mesh.GetNumFaces, "###,##0") & " Faces, " _
                & format$(m_d3dx_mesh.GetNumVertices, "###,##0") & " Vertices"
End Sub

'-----------------------------------------------------------------------------
'Name: UpdateShape()
'Desc:
'-----------------------------------------------------------------------------
Private Sub UpdateShape()
    Dim Adj As D3DXBuffer

    
    'make sure previous object is destroyed
    Set m_d3dx_mesh = Nothing
    
    'create shape
    Set m_d3dx_mesh = CreateShape(m_NumSegments, Adj)
    
    Call OptimizeMesh(m_d3dx_mesh, Adj)
    
    Set Adj = Nothing
End Sub

'-----------------------------------------------------------------------------
'Name: CreateShape()
'Desc:
'-----------------------------------------------------------------------------
Private Function CreateShape(ByVal NumSegments As Long, ByRef AdjOut As D3DXBuffer) As D3DXMesh
            
            Set CreateShape = g_d3dx.CreateTorus(g_dev, 0.02!, 0.2!, NumSegments, NumSegments, AdjOut)

End Function

'-----------------------------------------------------------------------------
'Name: CreateText()
'Desc: Create the mesh and the D3DXFont based on current
'      settings and reset device state.  (The matrices
'      depend on the mesh bounding box.)
'-----------------------------------------------------------------------------
Private Sub CreateText()
    Dim MyFont As IFont
    
    'create status font
    Set MyFont = frmMain.Font
    Set m_status_font = Nothing
    Set m_status_font = g_d3dx.CreateFont(g_dev, MyFont.hFont)
    Set MyFont = Nothing
End Sub

'-----------------------------------------------------------------------------
'Name: InitDeviceObjects()
'Desc: This creates all device-dependant managed objects, such as managed
'      textures and managed vertex buffers.
'-----------------------------------------------------------------------------
Public Sub InitDeviceObjects()
    '
End Sub

'-----------------------------------------------------------------------------
'Name: RestoreDeviceObjects()
'Desc: Restore device-memory objects and state after a device is created or
'      resized.
'-----------------------------------------------------------------------------
Public Sub RestoreDeviceObjects()
    'initialize text objects
    CreateText
    
    'create currently selected shape
    UpdateShape
    
    'build string for status text
    UpdateStatusText
    
    'set render states that we need
    SetStates
End Sub

'-----------------------------------------------------------------------------
'Name: InvalidateDeviceObjects()
'Desc: Called when the device-dependant objects are about to be lost.
'-----------------------------------------------------------------------------
Public Sub InvalidateDeviceObjects()
    Set m_status_font = Nothing
    Set m_d3dx_mesh = Nothing
End Sub

'-----------------------------------------------------------------------------
'Name: DeleteDeviceObjects()
'Desc: Called when the app is exiting, or the device is being changed,
'      this function deletes any device dependent objects.
'-----------------------------------------------------------------------------
Public Sub DeleteDeviceObjects()
    'device objects are no longer initialized
    m_bInit = False
End Sub

'-----------------------------------------------------------------------------
'Name: VerifyDevice()
'Desc: Called during device intialization, this code checks the device
'      for some minimum set of capabilities.
'-----------------------------------------------------------------------------
Public Function VerifyDevice(usageflags As Long, format As CONST_D3DFORMAT) As Boolean
    VerifyDevice = True
End Function

'-----------------------------------------------------------------------------
'Name: mnuChangeDevice_Click()
'Desc:
'-----------------------------------------------------------------------------
Private Sub mnuChangeDevice_Click()
    Form_KeyDown vbKeyF2, 0
End Sub

'-----------------------------------------------------------------------------
'Name: mnuExit_Click()
'Desc:
'-----------------------------------------------------------------------------
Private Sub mnuExit_Click()
    Unload Me
End Sub

'-----------------------------------------------------------------------------
'Name: mnuGoStop_Click()
'Desc:
'-----------------------------------------------------------------------------
Private Sub mnuGoStop_Click()
    If m_bIsRunning = True Then
        DXUtil_Timer TIMER_STOP
        m_bIsRunning = False
    Else
        DXUtil_Timer TIMER_start
        m_bIsRunning = True
    End If
End Sub

'-----------------------------------------------------------------------------
'Name: mnuSingleStep_Click()
'Desc:
'-----------------------------------------------------------------------------
Private Sub mnuSingleStep_Click()
    If m_bIsRunning = True Then
        DXUtil_Timer TIMER_STOP
        m_bIsRunning = False
    End If
    
    'manually advance time
    m_fTime = m_fTime + 0.1
End Sub

